<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Src/NLME/FirstStage/FirstStage_objs/WLS_gm.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_413f4e031a85da0d68269c6fd2f76e1c.html">Src</a></li><li class="navelem"><a class="el" href="../../dir_8672bca13fc16af0e54d5ddc01090308.html">NLME</a></li><li class="navelem"><a class="el" href="../../dir_ad567f6568f7af71f68706673af51f33.html">FirstStage</a></li><li class="navelem"><a class="el" href="../../dir_1c3bb113e33976697575615603529f5e.html">FirstStage_objs</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">WLS_gm.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d0/de2/_w_l_s__gm_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;% ======================================================================</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;% ======================================================================</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">function</span> [res,h,gm]=<a class="code" href="../../d0/de2/_w_l_s__gm_8m.html#a664af4d6d1b7d8d8d831606b4ee1ab86">WLS_gm</a>(f_t,noise_params,d,type,n_obs,varargin)</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keywordflow">if</span> ~isempty(varargin)</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    KeepNaN=1;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    KeepNaN=0;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;end</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keywordflow">if</span> any(f_t==Inf) %If integration had failed</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;res=Inf;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;h=Inf;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;gm=Inf;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;% Run model</div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="../../d0/de2/_w_l_s__gm_8m.html#a664af4d6d1b7d8d8d831606b4ee1ab86">   21</a></span>&#160;h=<a class="code" href="../../d8/d7b/var_fun_8m.html#ae8689ef39372b131ddb25d7da78d2b87">varFun</a>(noise_params,f_t,type,n_obs);</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;obs_id=unique(d.YID);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;d_obs=d.Y(d.YID==obs_id(n_obs));</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;nonans=~isnan(d_obs); % find NaN values</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;% Return values needed to evaluate the COST <span class="keyword">function</span>.</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;if (any(h(:)==Inf)||sum(log(h(:))==-Inf)||~any(isreal(log(h(:)))))</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;res=Inf;gm=Inf;h=Inf;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keywordflow">else</span>  </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordflow">if</span> KeepNaN==0</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    f_t=reshape(f_t(:,n_obs),length(d_obs),1);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    h=reshape(h,length(d_obs),1);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    res= d_obs(nonans)-f_t(nonans);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    h=h(nonans);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    gm=1/length(h)*sum(log(h));</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    f_t=reshape(f_t(:,n_obs),length(d_obs),1);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    h=reshape(h,length(d_obs),1);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    res= d_obs-f_t;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    gm=1/sum(~isnan(h))*nansum(log(h));</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    end</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;end</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;end</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="avar_fun_8m_html_ae8689ef39372b131ddb25d7da78d2b87"><div class="ttname"><a href="../../d8/d7b/var_fun_8m.html#ae8689ef39372b131ddb25d7da78d2b87">varFun</a></div><div class="ttdeci">function varFun(in noise_params, in f_t, in var_type, in varargin)</div><div class="ttdoc">varFun is a function that returns the variance model</div></div>
<div class="ttc" id="a_w_l_s__gm_8m_html_a664af4d6d1b7d8d8d831606b4ee1ab86"><div class="ttname"><a href="../../d0/de2/_w_l_s__gm_8m.html#a664af4d6d1b7d8d8d831606b4ee1ab86">WLS_gm</a></div><div class="ttdeci">function WLS_gm(in f_t, in noise_params, in d, in type, in n_obs, in varargin)</div><div class="ttdoc">WLS_gm is used by get_AR_gm and get_PL_gm.m Generates the things needed to compute the AR/ PL objecti...</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:30 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
